=== debian/changelog ===
xavs2 (1.3-1) unstable; urgency=medium

  [ Ondřej Nový ]
  * Bump Standards-Version to 4.4.0
  * Bump Standards-Version to 4.4.1

  [ Jonas Smedegaard ]
  * remove myelf as uploader

  [ Sebastian Ramacher ]
  * debian/:
    - Bump debhelper compat to 13
    - Remove d-shlibs
    - Remove pkgkde_symbolshelper
  * debian/control:
    - Set RRR: no
    - Update description
    - Add myself to Uploaders

 -- Sebastian Ramacher <sramacher@debian.org>  Sun, 11 Apr 2021 20:40:44 +0200

xavs2 (1.3-1~exp2) experimental; urgency=medium

  * Fix scrub manpages after help2man generation.
  * Add patches cherry-picked upstream:
    + Fix typos in command-line messages.
    + Adjust preset levels to decrease complexity.
  * Declare compliance with Debian Policy 4.3.0.
  * Add patch 1002 to fix architecture optimization.
    Stop avoid assembler on 32bit architectures.
  * Add symbols file.
  * Fix clean leftover objects and generated header after build.
  * Wrap and sort control file.
  * Resolve dependencies for and install shared library with d-shlibs.

 -- Jonas Smedegaard <dr@jones.dk>  Tue, 25 Dec 2018 16:09:00 +0100

xavs2 (1.3-1~exp1) experimental; urgency=low

  * Initial packaging release.
    Closes: bug#917162.

 -- Jonas Smedegaard <dr@jones.dk>  Sun, 23 Dec 2018 15:32:50 +0100
