## xavs2 1.4.1

=== build/linux/Makefile ===
--- 
+++ 
@@ -93,10 +93,10 @@
 		common/x86/x86inc.asm \
 		common/x86/x86util.asm 
 
-ifeq ($(SYS_ARCH),X86)
-ARCH_X86 = yes
-ASMSRC   = $(X86SRC) 
-endif
+#ifeq ($(SYS_ARCH),X86)
+#ARCH_X86 = yes
+#ASMSRC   = $(X86SRC) 
+#endif
 
 ## Until now, we do not have 64-bit asm
 ifeq ($(SYS_ARCH),X86_64)
@@ -133,12 +133,12 @@
 $(OBJASM): common/x86/x86inc.asm common/x86/x86util.asm
 endif
 
-ifdef ARCH_X86
-ASFLAGS += -I$(SRCPATH)/common/x86/
+#ifdef ARCH_X86
+#ASFLAGS += -I$(SRCPATH)/common/x86/
 #SRCS    += common/x86/mc-c.c common/x86/predict-c.c
-OBJASM  = $(ASMSRC:%.asm=%.o)
-$(OBJASM): common/x86/x86inc.asm common/x86/x86util.asm
-endif
+#OBJASM  = $(ASMSRC:%.asm=%.o)
+#$(OBJASM): common/x86/x86inc.asm common/x86/x86util.asm
+#endif
 
 # AltiVec optims
 ifeq ($(SYS_ARCH),PPC)
@@ -241,15 +241,15 @@
 
 $(OBJS) $(OBJAVX) $(OBJASM) $(OBJSO) $(OBJCLI) $(OBJCHK): .depend
 
-%.o: %.asm common/x86/x86inc.asm common/x86/x86util.asm
-	@echo "\033[33m [Compiling asm]: $< \033[0m"
-	$(AS) $(ASFLAGS) -o $@ $<
-	-@ $(if $(STRIP), $(STRIP) -x $@) # delete local/anonymous symbols, so they don't show up in oprofile
-
-%.o: %.S
-	@echo "\033[33m [Compiling asm]: $< \033[0m"
-	$(AS) $(ASFLAGS) -o $@ $<
-	-@ $(if $(STRIP), $(STRIP) -x $@) # delete local/anonymous symbols, so they don't show up in oprofile
+#%.o: %.asm common/x86/x86inc.asm common/x86/x86util.asm
+#	@echo "\033[33m [Compiling asm]: $< \033[0m"
+#	$(AS) $(ASFLAGS) -o $@ $<
+#	-@ $(if $(STRIP), $(STRIP) -x $@) # delete local/anonymous symbols, so they don't show up in oprofile
+
+#%.o: %.S
+#	@echo "\033[33m [Compiling asm]: $< \033[0m"
+#	$(AS) $(ASFLAGS) -o $@ $<
+#	-@ $(if $(STRIP), $(STRIP) -x $@) # delete local/anonymous symbols, so they don't show up in oprofile
 
 %.dll.o: %.rc xavs2.h
 	@echo "\033[33m [Compiling dll]: $< \033[0m"
