=== debian/changelog ===
xavs2 (1.4.1-1+dde) unstable; urgency=medium

  * update

 -- Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>  Sun, 25 Apr 2021 18:55:16 +0800

xavs2 (1.4.1-1+dde) unstable; urgency=low

  * fix: x86 compile

 -- muyuankai <muyuankai@uniontech.com>  Tue, 13 Apr 2021 10:10:30 +0800

xavs2 (1.4-1+dde) unstable; urgency=low

  * fix:Merge xavs2 from gitee addr:https://gitee.com/pkuvcl/xavs2

 -- muyuankai <muyuankai@uniontech.com>  Thu, 26 Nov 2020 10:10:30 +0800

xavs2 (1.3-1~exp3) UNRELEASED; urgency=medium

  [ Ondřej Nový ]
  * Bump Standards-Version to 4.4.0
  * Bump Standards-Version to 4.4.1

  [ Jonas Smedegaard ]
  * remove myelf as uploader

 -- Jonas Smedegaard <dr@jones.dk>  Mon, 24 Aug 2020 11:31:32 +0200
